package p21_jdbc.bazowe;

import javax.swing.*;
import java.sql.*;

public class E_UpdateWTransakcji {
    public static void main(String[] args) {
        final String url = "jdbc:postgresql://vps-2bc225bd.vps.ovh.net/hr";
        final String updateSql = "UPDATE employees SET salary = salary + ? WHERE job_id = ?";
        final String avgSql = "SELECT avg(salary) FROM employees WHERE job_id = ?";

        try(Connection c = DriverManager.getConnection(url, "alx", "abc123vps")) {
            // wyłączenie trybu auto-commit, a wejście w tryb transakcji
            // dopóki nie wykonamy commit, zmiany nie są zapisywane w sposób trwały
            c.setAutoCommit(false);
            // c.setTransactionIsolation(Connection.TRANSACTION_REPEATABLE_READ);

            try(PreparedStatement updateStmt = c.prepareStatement(updateSql);
                PreparedStatement avgStmt = c.prepareStatement(avgSql)) {

                String szukanyJob = JOptionPane.showInputDialog("Podaj kod stanowiska", "IT_PROG");
                avgStmt.setString(1, szukanyJob);
                try(ResultSet rs = avgStmt.executeQuery()) {
                    if(rs.next()) {
                        double avg = rs.getDouble(1);
                        JOptionPane.showMessageDialog(null, "Średnia pensja wynosi " + avg);
                    }
                }

                int zmiana = Integer.parseInt(JOptionPane.showInputDialog("Podaj zmianę pensji", "1000"));
                updateStmt.setInt(1, zmiana);
                updateStmt.setString(2, szukanyJob);
                int wynik = updateStmt.executeUpdate();
                JOptionPane.showMessageDialog(null, "Zmieniono " + wynik + " rekordów.");
                try(ResultSet rs = avgStmt.executeQuery()) {
                    if(rs.next()) {
                        double avg = rs.getDouble(1);
                        JOptionPane.showMessageDialog(null, "Średnia pensja wynosi teraz " + avg);
                    }
                }

                int wybor = JOptionPane.showConfirmDialog(null, "Czy zapisać zmiany?");
                switch(wybor) {
                    case JOptionPane.YES_OPTION -> c.commit();
                    case JOptionPane.NO_OPTION -> c.rollback();
                    case JOptionPane.CANCEL_OPTION -> {return;} // wcześniej przerywa program; połączenie zostanie zamknięte bez commita
                }

                try(ResultSet rs = avgStmt.executeQuery()) {
                    if(rs.next()) {
                        double avg = rs.getDouble(1);
                        JOptionPane.showMessageDialog(null, "Średnia pensja wynosi teraz " + avg);
                    }
                }
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
}
