package p22_jaxb.programy;

import jakarta.xml.bind.JAXBContext;
import jakarta.xml.bind.JAXBException;
import jakarta.xml.bind.Marshaller;
import jakarta.xml.bind.Unmarshaller;
import p22_jaxb.model.ArrayOfExchangeRatesTable;
import p22_jaxb.model.ExchangeRatesTable;
import p22_jaxb.model.Rate;

import java.io.File;
import java.math.BigDecimal;
import java.time.LocalDate;

public class OdczytajWaluty {
    public static void main(String[] args) {
        try {
            JAXBContext ctx = JAXBContext.newInstance(ArrayOfExchangeRatesTable.class);
            // Jeśli pakiet zawiera klasę ObjectFactory, to można też nazwę pakietu:
            // JAXBContext ctx = JAXBContext.newInstance("p22_jaxb.model");
            Unmarshaller u = ctx.createUnmarshaller();
            ArrayOfExchangeRatesTable array = (ArrayOfExchangeRatesTable) u.unmarshal(new File("pliki/waluty2023.xml"));
            System.out.println("Udało się wczytać, lista zawiera " + array.getExchangeRatesTable().size() + " tabel.");

            String kod = "EUR";
            System.out.println("Wypiszę kolejne kursy waluty " + kod + ":");
            for (ExchangeRatesTable table : array.getExchangeRatesTable()) {
                System.out.print(table.getEffectiveDate() + ": ");
                table.getRates().stream().filter(rate -> rate.getCode().equals(kod)).findFirst().ifPresent(rate -> System.out.print(rate.getMid()));
                System.out.println();
            }

        } catch (JAXBException e) {
            throw new RuntimeException(e);
        }


    }
}
