package p22_jaxb.programy;

import jakarta.xml.bind.JAXBContext;
import jakarta.xml.bind.JAXBException;
import jakarta.xml.bind.Marshaller;
import p22_jaxb.model.ArrayOfExchangeRatesTable;
import p22_jaxb.model.ExchangeRatesTable;
import p22_jaxb.model.Rate;

import java.math.BigDecimal;
import java.time.LocalDate;

public class ZapiszPrzykladoweWaluty {
    public static void main(String[] args) {
        ExchangeRatesTable table = new ExchangeRatesTable("A", "A/120/2024", LocalDate.of(2024, 5, 25));
        table.addRate(new Rate("dolar", "USD", new BigDecimal("4.2000")));
        table.addRate(new Rate("euro", "EUR", new BigDecimal("4.5000")));
        ArrayOfExchangeRatesTable array = new ArrayOfExchangeRatesTable(table);
        System.out.println(array);
        System.out.println();

        try {
            JAXBContext ctx = JAXBContext.newInstance(ArrayOfExchangeRatesTable.class);
            Marshaller marshaller = ctx.createMarshaller();
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            marshaller.marshal(array, System.out);
        } catch (JAXBException e) {
            throw new RuntimeException(e);
        }


    }
}
